<?php

session_start();
ob_start();
$do = isset($_GET['do']) ? $_GET['do'] : "";
$ajaxDoArr = array("add2SimpleReturn");
include("initiateStaticSessionCommingWithCurl.php");
if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
    array_push($ajaxDoArr, $do);
}

if (!in_array($do, $ajaxDoArr)) {
    include("../public/impOpreation.php");
}



include_once("../public/config.php");
include("../library/newUplode/uploadfunctions.php");


require_once('../models/dao/YoutubeLinkDAO.class.php');
require_once('../models/dto/YoutubeLink.class.php');
require_once('../models/mysql/YoutubeLinkMySqlDAO.class.php');
require_once('../models/mysql/ext/YoutubeLinkMySqlExtDAO.class.php');




//get the do the action
$do = $_GET['do'];

$langs = $_SESSION['erp_lang'];
include_once("../views/languages/$langs/success.php");
include_once("../views/languages/$langs/error.php");


if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("header.html");
    }
}



$youtubeLink = new YoutubeLink();
$youtubeLinkDAO = new YoutubeLinkMySqlDAO();
$youtubeLinkEX = new YoutubeLinkMySqlExtDAO();

$today = date("Y-m-d");
//check and use the condition that suite this action
if (empty($do)) {
    //here the permission check
    
    $allTenders = R::findAll('tenderannouncement', "status = 'avilable' AND isdel = 0");
    $smarty->assign('allTenders', $allTenders);
    $acceptedMembers = R::findAll('memberships', "request_status = 'accepted' AND isdel = 0");
    $smarty->assign('allMembers', $acceptedMembers);
    $smarty->display("bidRequestView/add.html");
} elseif ($do == "add") {
    try { 
    
        add();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        echo $e;
        die();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "show") {
    
    $sql="SELECT br.*, m.member_name, t.name, t.the_issuing_entity, u.employeename 
            FROM bidrequest br
            JOIN memberships m ON br.member_id = m.id
            JOIN tenderannouncement t ON br.op_id = t.id
            LEFT JOIN user u ON br.userid = u.userid 
            WHERE br.isdel = 0";
    $showData =R::getAll($sql);
    $smarty->assign('showData', $showData);

    $youtubes = $youtubeLinkDAO->queryAll();
    $smarty->assign("youtubes", $youtubes);

    $smarty->display("bidRequestView/show.html");
    $smarty->assign("customCheck", 1);
} elseif ($do == "deleteFinaly") {
    try {
        $id = (int) $_GET['id'];
        deleteFinaly($id);

        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "edit") { //edit request
    $id = $_GET['id'];
    $showData = R::load('bidrequest', $id);
    $sql = " (status = 'avilable' AND isdel = 0) OR id = ? ";
    $tenders = R::findAll('tenderannouncement', $sql, [$showData->op_id]);
    $acceptedMembers = R::findAll('memberships', "request_status = 'accepted' AND isdel = 0");
    $smarty->assign('showData', $showData);
    $smarty->assign('tenders', $tenders);
    $smarty->assign('allMembers', $acceptedMembers);
    $smarty->display("bidRequestView/edit.html");
    
} elseif ($do == "report") { 
    
    $sql = "SELECT br.*, m.member_name, t.name as tender_name, t.the_issuing_entity, u.employeename 
            FROM bidrequest br
            JOIN memberships m ON br.member_id = m.id
            JOIN tenderannouncement t ON br.op_id = t.id
            LEFT JOIN user u ON br.userid = u.userid 
            WHERE br.isdel = 0 
            ORDER BY br.id DESC";
            
    $showData = R::getAll($sql);
    $smarty->assign('showData', $showData);
    
    $smarty->display("bidRequestView/report.html");
    
} elseif ($do == "view") { //edit request
    $id = $_GET['id'];
    $showData = R::load('bidrequest', $id);
    $sql = " (status = 'avilable' AND isdel = 0) OR id = ? ";
    $tenders = R::findAll('tenderannouncement', $sql, [$showData->op_id]);
    $acceptedMembers = R::findAll('memberships', "request_status = 'accepted' AND isdel = 0");
    $smarty->assign('showData', $showData);
    $smarty->assign('tenders', $tenders);
    $smarty->assign('allMembers', $acceptedMembers);
    $smarty->display("bidRequestView/view.html");
} elseif ($do == "update") { //edit update
    try {
        update();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "sucess") {
    //here the smarty templates
    $smarty->display("succes.html");
} elseif ($do == "error") {
    //here the smarty templates
    $smarty->display("error.html");
}


$smarty->assign("customValidation", 1);

//here the global templates
if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("footer.html");
    }
}

/* ===============================
  function in this CONTROLLER
  ================================ */

// add in tenderannouncement tbl
function add() {
    $name = $_POST['name'];
    $image = uploadnew('image', False, 0, 0, 'bidRequest');
    $session = $_POST['session'];
    $member_id = $_POST['member_id'];
    
    $rdispense = R::dispense('bidrequest');
    $rdispense->member_id = $member_id;
    $rdispense->op_id = $name;
    $rdispense->image = $image;
    $rdispense->session_date = $session;
    $rdispense->sys_date = date("Y-m-d H:i:s");
    $rdispense->userid = $_SESSION['userid'];
    $rdispense->isdel = 0;
    $id = R::store($rdispense);
    return $id;
}

function update() {

    $id = $_POST['id'];
    $name = $_POST['name'];
    $image = uploadupdate('image', 'imageurl', False, 0, 0, 'bidRequest');
    $session = $_POST['session'];
    $member_id = $_POST['member_id'];
    $rupdate = R::load('bidrequest', $id);
    $rupdate->member_id = $member_id;
    $rupdate->op_id = $name;
    $rupdate->image = $image;
    $rupdate->session_date = $session;
    $rupdate->sys_date = date("Y-m-d H:i:s");
    $rupdate->userid = $_SESSION['userid'];
    $rupdate->isdel = 0;
    $id = R::store($rupdate);
}

function deleteFinaly($id) { 
    
    $rupdates = R::load('bidrequest', $id);
    
    if ($rupdates->id > 0) {
        $rupdates->isdel = 1;
        R::store($rupdates);
    }
}